unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,Win2K;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ON_WM_HOTKEY(var m:TMessage);message WM_HOTKEY;
  private
    { Private declarations }
    procedure AppMessage(var msg : TMsg; var handled : boolean);
    procedure MinimizeAllWindow;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  hTaskBar:Hwnd;

implementation

{$R *.DFM}
uses PasWordDlg;


procedure TForm1.AppMessage(var msg : TMsg; var handled : boolean);
begin
  //Screen Saver
  if (Msg.Message = WM_SYSCOMMAND) and (Msg.wParam = SC_SCREENSAVE) then
    Handled := true;

  // let your application handle all messages initially
  Handled := FALSE;
  case Msg.Message of
    WM_SYSKEYDOWN,WM_SYSCHAR :
      if Msg.wParam = VK_F4 then
        Handled := TRUE; // don't allow ALT-F4
  end;
end;


procedure ShowStartButton(bvisible : boolean);
var
  h : hwnd;
  TaskWindow : hwnd;
begin
  if bvisible then
  begin
    h := FindWindowEx(GetDesktopWindow,0,'Button',nil);
    TaskWindow := FindWindow('Shell_TrayWnd', nil);
    ShowWindow(h,1);
    Windows.SetParent(h,TaskWindow);
  end else
  begin
    h := FindWindowEx(FindWindow('Shell_TrayWnd', nil),0,'Button',nil);
    ShowWindow(h,0);
    Windows.SetParent(h,0);
  end;
end;


procedure TForm1.ON_WM_HOTKEY(var m: TMessage);
begin
  if(m.WParam=123)then //pGidO123
    ShowMessage('OK');   
end;




procedure TForm1.FormCreate(Sender: TObject);
begin
  SetLayeredWindowAttributes(Handle,0,50,LWA_ALPHA);

  Application.OnMessage := AppMessage;

  MinimizeAllWindow;

  HTaskBar:=FindWindow('Shell_TrayWnd',nil);
  ShowWindow(HTaskbar,SW_HIDE); //Hide the taskbar
  ShowStartButton(false);

  RegisterHotKey(Handle,123,MOD_ALT,integer(VK_TAB));
end;

function CheckPassword:boolean;
const
  PassAry='1234';
begin
  result:=false;
  PassWdlg.ShowModal;
  try
    if (PassWdlg.ModalResult=mrOk) then
    begin
      if (PassWdlg.Edit1.Text=PassAry) then
      begin
        result:=true;
      end
      else
      begin
        ShowMessage('Not a valid password!');
        result:=false;
      end;
    end;
  finally
    //PassWdlg.free;
  end;
end;

procedure TForm1.MinimizeAllWindow;
var
  h:HWnd;
  buf:Array[1..255] of char;
  str:String;
begin
  h:=handle;
  while h > 0 do 
  begin
    if isWindowVisible(h) then
      postmessage(h,WM_SYSCOMMAND,SC_MINIMIZE,0);

    GetClassName(h,@buf,255);
    str:=String(buf);
    str:=copy(str,1,pos(#0,str)-1);
    if (Uppercase(Str)='IEFRAME') then
     SendMessage(h, wm_Close, 0, 0);
    
    h:=getnextwindow(h,GW_HWNDNEXT); 
  end; 
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE:
      if CheckPassWord then Close;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ShowWindow(HTaskbar,SW_Show); //Show the taskbar
  ShowStartButton(true);
end;

end.
